﻿// ############################# MyTable.cs #####################################
using System;
using System.Windows.Forms; 
using System.Drawing;  
using System.Collections.Generic; 

public class MyTable : Panel { 
    public int bandD=20, bandH=30, bandDH, bandDHH, bandF=90;
    Brush dbrush=new SolidBrush(Color.Orchid); 
    Pen bkpen=new Pen(Color.Black, 1);
    int xinit, yinit; 
    int xnow, ynow; 
    Pen pen=new Pen(Color.Gray, 1);
    Pen gpen=new Pen(Color.Green, 1);
    public int xdeviinit=170, ydeviinit=170; 
    public int xdevifinal, ydevifinal;
    List<bool> xopen, yopen; 
    Font ここでのfont = new Font("ＭＳ Ｐゴシック", 14);  
    Font 数のfont = new Font("ＭＳ Ｐゴシック", 12);  
    Brush 緑のブラシ = new SolidBrush(Color.DarkGreen); 
    Brush redbrush = new SolidBrush(Color.Red), graybrush=new SolidBrush(Color.Gray); 
    public int ysz=0, xsz=0; 
    public List<int> pxs, pys; 
    MyForm par;
    public List<string> xtitles, ytitles;
    List<int> multiplierx, multipliery; 
    List<long> accumy, accumx; 
    public Term[,] terms; 
    long totalsum; 
    public MyTable(MyForm partf) {
        par=partf;
        this.BackColor = Color.White; //        Yellow; 
        getpxs();
        getpys(); 
        OnClick(null);  
        bandDH=bandD+bandH;
        bandDHH=bandD+bandH+bandH; 
        par=partf; 
        recalcu();
        xopen=new List<bool>(); 
        yopen=new List<bool>(); 
        xtitles=new List<string>(); 
        ytitles=new List<string>();
        multiplierx=new List<int>();
        multipliery=new List<int>();
        accumx=new List<long>();
        accumy=new List<long>();  
    } // ======================================================= 
    public void getpxs() {
        pxs = new List<int>(); 
        int xdevi=xdeviinit; 
        for (int x=0 ; x<=xsz; x++) { 
            pxs.Add(xdevi);   
            if (x==xsz) {break; } 
            if (xopen[x]) { 
                xdevi+=bandDHH; 
            } else {
                xdevi+=bandD; } }
        int w=pxs[xsz]+bandF+3; 
        if (this.Width!=w) {
            this.Width=w; } 
    } // ======================================================= 
    public void getpys() {
        pys = new List<int>(); 
        int ydevi=ydeviinit; 
        for (int y=0 ; y<=ysz; y++) {
            pys.Add(ydevi); 
            if (y==ysz) {break; } 
            if (yopen[y]) { 
                ydevi += bandDHH; 
            } else { 
                ydevi+=bandD; } } 
        int h=pys[ysz]+bandF+3; 
        if (this.Height!=h) {
            this.Height=h; } 
    } // ======================================================= 
    public void onmousemove(int xonpanel, int yonpanel) { 
        int xnowprev=xnow, ynowprev=ynow; 
        if (xmode && yonpanel>0 && yonpanel < ydevifinal+bandF && xonpanel >= xdeviinit) {
            for (xnow=0; xnow<xsz; xnow++) { 
                if (pxs[xnow+1] > xonpanel) {break; } } 
        } else if (ymode && xonpanel>0 && xonpanel < xdevifinal+bandF && yonpanel >= ydeviinit) { 
            for (ynow=0; ynow<ysz; ynow++) { 
                if (pys[ynow+1] > yonpanel) {break; } } }
        if (xnowprev != xnow || ynowprev != ynow) { 
            Invalidate(); }  
    } // ======================================================= 
    public void paint(Graphics g) { 
        int xdevi, ydevi;
        xdevifinal = pxs[xsz];
        ydevifinal = pys[ysz]; 
        for (int x=0;x<=xsz ; x++) { // vertical lines 
            g.DrawLine(pen, pxs[x], 0, pxs[x], ydevifinal+bandF); } 
        for (int y=0;y<=ysz ; y++) { // horizontal lines 
            g.DrawLine(pen, 0, pys[y], xdevifinal+bandF, pys[y]); } 
        if (ymode) {
            g.FillRectangle(dbrush, 0, pys[yinit], pxs[xsz]+bandF, pys[yinit+1]-pys[yinit]); } 
        if (xmode) {
            g.FillRectangle(dbrush, pxs[xinit], 0, pxs[xinit+1]-pxs[xinit], pys[ysz]+bandF); }  
        g.DrawLine(gpen, 0, ydevifinal+bandF, xdevifinal+bandF, ydevifinal+bandF); // bottom line 
        g.DrawLine(gpen, xdevifinal+bandF, 0, xdevifinal+bandF, ydevifinal+bandF); // right line  
        if (xmode) { 
            if (xinit < xnow && xnow < xsz) {
                g.DrawLine(bkpen, pxs[xnow+1], 0, pxs[xnow+1], ydevifinal+bandF); 
            } else if (xnow < xinit) {
                g.DrawLine(bkpen, pxs[xnow], 0, pxs[xnow], ydevifinal+bandF); } 
        } else if (ymode) {
            if (yinit < ynow && ynow < ysz) {
                g.DrawLine(bkpen, 0, pys[ynow+1], xdevifinal+bandF, pys[ynow+1]); 
            } else if (ynow < yinit) {
                g.DrawLine(bkpen, 0, pys[ynow], xdevifinal+bandF, pys[ynow]); } } 
        // ---------------------------------------------------------------- 
        ydevi=ydeviinit; 
        for (int y=0; y<ysz; y++) {  
            Brush brush=緑のブラシ; 
            if (multipliery[y] < 0) {
                brush=redbrush; 
            } else if (multipliery[y] == 0) {
                brush=graybrush; 
            }  
            if (yopen[y]) { 
                ydevi+=bandH; } 
            horizright(g, ytitles[y], ここでのfont, brush, xdeviinit, ydevi);  
            if (yopen[y]) { 
                ydevi+=bandDH; 
            } else { 
                ydevi+=bandD; 
            } 
        } 
        xdevi=xdeviinit; 
        for (int x=0; x<xsz; x++) { 
            Brush brush=緑のブラシ; 
            if (multiplierx[x] < 0) {
                brush=redbrush; 
            } else if (multiplierx[x] == 0) {
                brush=graybrush; 
            }  
            if (xopen[x]) {
                xdevi += bandH; 
            } 
            vertleft(g, xtitles[x], ここでのfont, brush, xdevi, ydeviinit); 
            if (xopen[x]) {  
                xdevi+=bandDH; 
            } else { 
                xdevi+=bandD; } } 
        // ---------------------------------------------------------------- 
        xdevi=xdeviinit; 
        for (int x=0; x<xsz; x++) { 
            ydevi=ydeviinit; 
            if (xopen[x]) { 
                xdevi += bandDHH; 
                for (int y=0; y<ysz; y++) {
                    Brush brush=緑のブラシ; 
                    if (multipliery[y]*multiplierx[x] < 0) {
                        brush=redbrush; 
                    } else if (multipliery[y]*multiplierx[x] == 0) {
                        brush=graybrush; 
                    }  
                    if (yopen[y]) {  
                        cantright(g, terms[x,y].final.ToString("n0"), 数のfont, brush, xdevi, ydevi);  
                        ydevi+=bandDHH; 
                    } else { 
                        horizright(g, terms[x,y].final.ToString("n0"), 数のfont, brush, xdevi, ydevi);  
                        ydevi+=bandD; 
                    } 
                }
                xdevi += 0; 
            } else { 
                for (int y=0; y<ysz; y++) {
                    Brush brush=緑のブラシ; 
                    if (multipliery[y]*multiplierx[x] < 0) {
                        brush=redbrush; 
                    } else if (multipliery[y]*multiplierx[x] == 0) {
                        brush=graybrush; 
                    }  
                    if (yopen[y]) { 
                        vertright(g, terms[x,y].final.ToString("n0"), 数のfont, brush, xdevi, ydevi); 
                        ydevi+=bandDHH; 
                    } else { 
                        if (terms[x,y].final>0) { 
                            g.DrawString("+", ここでのfont, brush, xdevi+3, ydevi+1); 
                        } else if (terms[x,y].final<0) {
                            g.DrawString("-", ここでのfont, brush, xdevi+3, ydevi+1); 
                        } 
                        ydevi+=bandD; 
                    } 
                }  
                xdevi += bandD; } }
        ydevi=ydeviinit;  
        xdevi += bandF; 
        for (int y=0; y<ysz; y++) {
            Brush brush=緑のブラシ; 
            if (multipliery[y] < 0) {
                brush=redbrush; 
            } else if (multipliery[y] == 0) {
                brush=graybrush; 
            }  
            if (yopen[y]) {  
                cantright(g, accumy[y].ToString("n0"), 数のfont, brush, xdevi, ydevi);  
                ydevi+=bandDHH; 
            } else { 
                horizright(g, accumy[y].ToString("n0"), 数のfont, brush, xdevi, ydevi);  
                ydevi+=bandD; } }  
        xdevi=xdeviinit;
        ydevi=ydevifinal; 
        for (int x=0; x<xsz; x++) {
            Brush brush=緑のブラシ; 
            if (multiplierx[x] < 0) {
                brush=redbrush; 
            } else if (multiplierx[x] == 0) {
                brush=graybrush; 
            }  
            if (xopen[x]) { 
                xdevi += bandDHH; 
                cantright(g, accumx[x].ToString("n0"), 数のfont, brush, xdevi, ydevi);  
            } else {
                vertright(g, accumx[x].ToString("n0"), 数のfont, brush, xdevi, ydevi);  
                xdevi += bandD; } }  
        cantright(g, totalsum.ToString("n0"), 数のfont, 緑のブラシ, xdevifinal+bandF, ydevifinal);   
        StringFormat sfall=new StringFormat(); 
    } // ============================================================== 
    public void scantitlex(int xonpanel) { 
        for (int x=0; x<xsz; x++) { 
            if (pxs[x+1] > xonpanel) { 
                if (xinit == x) { 
                    xopen[x]=!xopen[x];   
                } else { 
                    string xres=xtitles[xinit];
                    bool bres=xopen[xinit]; 
                    for (int y=0; y<ysz; y++) {
                        lres[y]=terms[xinit,y]; }
                    long ares=accumx[xinit];
                    int mres=multiplierx[xinit]; 
                    if (xinit < x) { 
                        for (int xsc=xinit; xsc<x; xsc++) { 
                            xtitles[xsc]=xtitles[xsc+1];
                            xopen[xsc]=xopen[xsc+1]; 
                            for (int y=0; y<ysz; y++) {
                                terms[xsc,y]=terms[xsc+1,y]; }
                            accumx[xsc]=accumx[xsc+1];
                            multiplierx[xsc]=multiplierx[xsc+1]; 
                        }
                    } else {
                        for (int xsc=xinit; xsc>x; xsc--) { 
                            xtitles[xsc]=xtitles[xsc-1];
                            xopen[xsc]=xopen[xsc-1]; 
                            for (int y=0; y<ysz; y++) {
                                terms[xsc,y]=terms[xsc-1,y]; } 
                            accumx[xsc]=accumx[xsc-1]; 
                            multiplierx[xsc]=multiplierx[xsc-1]; 
                        } 
                    } 
                    xtitles[x]=xres;
                    xopen[x]=bres; 
                    for (int y=0; y<ysz; y++) {
                        terms[x,y]=lres[y]; }
                    accumx[x]=ares;
                    multiplierx[x]=mres; 
                } 
                getpxs(); 
                Invalidate(); 
                break; } } 
    } // ======================================== 
    public void scantitley(int yonpanel) { 
        for (int y=0; y<ysz; y++) { 
            if (pys[y+1] > yonpanel) { 
                if (yinit == y) {
                    yopen[y]=!yopen[y];   
                } else { 
                    string yres=ytitles[yinit];
                    bool bres=yopen[yinit]; 
                    for (int x=0; x<xsz; x++) {
                        lres[x]=terms[x,yinit]; }
                    long ares=accumy[yinit]; 
                    int mres=multipliery[yinit]; 
                    if (yinit < y) { 
                        for (int ysc=yinit; ysc<y; ysc++) { 
                            ytitles[ysc]=ytitles[ysc+1];
                            yopen[ysc]=yopen[ysc+1]; 
                            for (int x=0; x<xsz; x++) {
                                terms[x,ysc]=terms[x,ysc+1]; }
                            accumy[ysc]=accumy[ysc+1];
                            multipliery[ysc]=multipliery[ysc+1];
                        }
                    } else {
                        for (int ysc=yinit; ysc>y; ysc--) { 
                            ytitles[ysc]=ytitles[ysc-1];
                            yopen[ysc]=yopen[ysc-1]; 
                            for (int x=0; x<xsz; x++) {
                                terms[x,ysc]=terms[x,ysc-1]; } 
                            accumy[ysc]=accumy[ysc-1]; 
                            multipliery[ysc]=multipliery[ysc-1];
                        } 
                    } 
                    ytitles[y]=yres;
                    yopen[y]=bres; 
                    for (int x=0; x<xsz; x++) {
                        terms[x,y]=lres[x]; }
                    accumy[y]=ares;
                    multipliery[y]=mres; 
                }  
                getpys(); 
                Invalidate();  
                break; } } 
    } // =================================================== 
    public void scanxy(int xonpanel, int yonpanel) {  
        int xfinal, yfinal; 
        for (xfinal=0; xfinal<xsz; xfinal++) { 
            if (pxs[xfinal+1] > xonpanel) {  
                break; } } 
        for (yfinal=0; yfinal<ysz; yfinal++) { 
            if (pys[yfinal+1] > yonpanel) {  
                break; } } 
        if (xfinal == xinit && yfinal == yinit) {
            TermForm tf=new TermForm(terms[xfinal, yfinal], par.strbase, xtitles[xfinal], ytitles[yfinal]);
            tf.textmulti.Text=terms[xfinal, yfinal].strincidents; 
            foreach (string str in terms[xfinal, yfinal].files) {
                tf.combo.Items.Add(str); } 
            // 
            Point pto=new Point(pxs[xfinal+1], pys[yfinal]);
            tf.location=new Point(xtoglobal(pto.X), ytoglobal(pto.Y)); 
            // 
            DialogResult dr=tf.ShowDialog(); 
            if (dr == DialogResult.OK) {
                terms[xfinal, yfinal].final=tf.term.final; // long.Parse(tf.textfinal.Text); 
                terms[xfinal, yfinal].strincidents=tf.textmulti.Text;
                terms[xfinal, yfinal].files.Clear(); 
                foreach (string str in tf.combo.Items) { 
                    terms[xfinal, yfinal].files.Add(str); } 
                recalcu(); } }  
    } // ===================================================  
    public void settitles(List<string> xtitlestf, List<string> ytitlestf) {
        xtitles=xtitlestf; ytitles=ytitlestf; 
        xsz=xtitles.Count; ysz=ytitles.Count; 
        xopen=new List<bool>(); yopen=new List<bool>(); 
        terms=new Term[xsz, ysz]; 
        accumx=new List<long>(); accumy=new List<long>();
        multiplierx=new List<int>(); 
        multipliery=new List<int>(); 
        for (int x=0; x<xsz; x++) {
            xopen.Add(false); 
            multiplierx.Add(1); 
            accumx.Add(0); 
            for (int y=0; y<ysz; y++) {
                terms[x, y]=new Term(); } } 
        for (int y=0; y<ysz; y++) {
            yopen.Add(false); 
            multipliery.Add(1); 
            accumy.Add(0); } 
        getpxs();
        getpys(); 
    } // ======================================================= 
    public void setcontent(int x, int y, string stra, string strb) {
        terms[x, y].setfiles(stra);
        terms[x, y].strincidents=strb; 
    } // ======================================================= 
    public void recalcu() { 
        for (int x=0; x<xsz; x++) {  
            accumx[x]=0;
            if (xtitles[x].Substring(0,1) == "-") {
                multiplierx[x]=-1; 
            } else if (xtitles[x].Substring(0,1) == "0") {
                multiplierx[x]=0; 
            } else { 
                multiplierx[x]=1; } } 
        totalsum=0; 
        for (int y=0; y<ysz; y++) { 
            accumy[y]=0; 
            if (ytitles[y].Length > 0 && ytitles[y].Substring(0,1) == "-") { 
                multipliery[y]=-1; 
            } else if (ytitles[y].Substring(0,1) == "0") { 
                multipliery[y]=0; 
            } else { 
                multipliery[y]=1; 
            } 
            for (int x=0; x<xsz; x++) { 
                long v=terms[x, y].final; 
                accumx[x] += v*multipliery[y]; 
                accumy[y] += v*multiplierx[x]; } 
            totalsum += accumy[y]*multipliery[y]; } 
    } // ======================================================= 
    void vertright(Graphics g, string str, Font font, Brush brush, int x, int y) {  
        int w = (int) g.MeasureString(str, font).Width; 
        g.RotateTransform(270F); 
        g.DrawString(str, font, brush, new Point(-y-w, x));  
        g.ResetTransform(); 
    } // ======================================================= 
    void vertleft(Graphics g, string str, Font font, Brush brush, int x, int y) {  
        g.RotateTransform(270F); 
        g.DrawString(str, font, brush, new Point(-y, x));  
        g.ResetTransform(); 
    } // ======================================================= 
    void horizright(Graphics g, string str, Font font, Brush brush, int x, int y) { 
        int w = (int) g.MeasureString(str, font).Width;  
        g.DrawString(str, font, brush, new Point(x-w, y));  
        g.ResetTransform(); 
    } // ======================================================= 
    void cantright(Graphics g, string str, Font font, Brush brush, int x, int y) { 
        int w = (int) g.MeasureString(str, font).Width;
        g.TranslateTransform(x, y); 
        g.RotateTransform(315F); 
        g.DrawString(str, font, brush, new Point(-w-10, -11));  
        g.ResetTransform(); 
    } // =======================================================  
    protected override void OnPaint (PaintEventArgs e) { 
        Graphics g=e.Graphics; 
        Pen redpen=new Pen(Color.Red, 1); 
        g.DrawRectangle(redpen, new Rectangle(0,0,this.Width-1,this.Height-1));
        paint(g);  
    } // ======================================================= 
    public bool xmode=false, ymode=false, xymode=false;  
    protected override void OnMouseDown (MouseEventArgs e) {
        int xonpanel=e.X, yonpanel=e.Y;   
        if (e.Button == System.Windows.Forms.MouseButtons.Left) {mousedownleft(xonpanel, yonpanel); 
        } else {mousedownright(xonpanel, yonpanel); } 
    } // =============================================================================== 
    protected override void  OnMouseMove(MouseEventArgs e) { 
        int xonpanel=e.X, yonpanel=e.Y;   
        onmousemove(xonpanel, yonpanel);  
    } // ======================================================= 
    protected override void OnMouseUp (MouseEventArgs e) { 
        int xonpanel=e.X, yonpanel=e.Y;   
        if (xmode && yonpanel>0 && yonpanel < ydeviinit && xonpanel >= xdeviinit) {
            scantitlex(xonpanel);  
        } else if (ymode && xonpanel>0 && xonpanel < xdeviinit && yonpanel >= ydeviinit) { 
            scantitley(yonpanel);  
        } else if (xymode && xonpanel >= xdeviinit && yonpanel >= ydeviinit 
                            && xonpanel < xdevifinal && yonpanel < ydevifinal) { 
            scanxy(xonpanel, yonpanel); } 
        xmode=ymode=xymode=false;  
        Invalidate(); 
    } // ======================================================= 
    public void mousedownleft(int xonpanel, int yonpanel) { 
        if (yonpanel>0 && yonpanel < ydeviinit && xonpanel >= xdeviinit) { // on x titles 
            for (xinit=0; xinit<xsz; xinit++) { 
                if (pxs[xinit+1] > xonpanel) { 
                    xmode=true; 
                    break; } } 
        } else if (xonpanel>0 && xonpanel < xdeviinit && yonpanel >= ydeviinit) { // on y titles 
            for (yinit=0; yinit<ysz; yinit++) { 
                if (pys[yinit+1] > yonpanel) { 
                    ymode=true; 
                    break; } } 
        } else if (xonpanel >= xdeviinit && yonpanel >= ydeviinit && xonpanel < xdevifinal && yonpanel < ydevifinal) {
            for (xinit=0; xinit<xsz; xinit++) { 
                if (pxs[xinit+1] > xonpanel) {  
                    break; } } 
            for (yinit=0; yinit<ysz; yinit++) { 
                if (pys[yinit+1] > yonpanel) {  
                    break; } }
            xymode=true; } 
        Invalidate(); 
    } // =============================================================================== 
    public void mousedownright(int xonpanel, int yonpanel) { 
        if (yonpanel>0 && yonpanel < ydeviinit && xonpanel >= xdeviinit) { // x titles 
            for (xinit=xsz; xinit>=0; xinit--) { 
                if (pxs[xinit] <= xonpanel) {
                    string titleconv = "";  if (xinit < xsz)  { titleconv=xtitles[xinit]; }  
                    righttitile(titleconv, true, xinit, xsz);  break; } } 
        } else if (xonpanel>0 && xonpanel < xdeviinit && yonpanel >= ydeviinit) { // y titles 
            for (yinit=ysz; yinit>=0; yinit--) { 
                if (pys[yinit] <= yonpanel) {  
                    string titleconv = "";  if (yinit < ysz)  { titleconv=ytitles[yinit]; }   
                    righttitile(titleconv, false, yinit, ysz);  break; } } } 
    } // ======================================================= 
    void righttitile(string str, bool xf, int nfix, int sz) {
        FormSelection formpre; 
        if (nfix == sz) { 
            formpre=new FormSelection(new string[]{"insert","nop"}); 
        } else {
            formpre=new FormSelection(new string[]{"remove","insert","rename","nop"}); } 
        formpre.Activated+=(o, e) => { 
            if (xf) {formpre.Location=new Point(xtoglobal(pxs[nfix]), ytoglobal(pys[0])); 
            } else {formpre.Location=new Point(xtoglobal(pxs[0]), ytoglobal(pys[nfix])); } };
        DialogResult drpre=formpre.ShowDialog(); 
        string strsele=formpre.list.SelectedItem.ToString(); 
        if (strsele == "rename") { 
            if (xf) { 
                rcorrecttitle(xtitles[nfix], xf, nfix, "rename");  
            } else { 
                rcorrecttitle(ytitles[nfix], xf, nfix, "rename");  } 
            recalcu(); 
            Invalidate(); 
        } else if (strsele == "remove") {
            remove(xf, nfix);
            recalcu(); 
            Invalidate(); 
        } else if (strsele == "insert") {
            insert(xf, nfix); // === here xsz increases 
            rcorrecttitle("", xf, nfix, "set title");  
            recalcu(); 
            Invalidate(); }  
        if (xf) {
            getpxs();  
        } else {
            getpys(); }  
    } // =============================================================================== 
    void rcorrecttitle(string strz, bool xf, int nfix, string strbutton) { 
        Form formhere=new Form(); 
        formhere.Size=new Size(310, 160);
        TextBox texthere=new TextBox();
        texthere.Size=new Size(260, 20);
        texthere.Location=new Point(20, 30);
        Button buttonOK=new Button(), buttonCancel=new Button();  
        buttonOK.Location=new Point(60, 70); buttonCancel.Location=new Point(160, 70); 
        buttonOK.Size=new Size(80, 20); buttonCancel.Size=new Size(80, 20); 
        formhere.Controls.Add(texthere); formhere.Controls.Add(buttonOK); 
            formhere.Controls.Add(buttonCancel); 
            buttonOK.DialogResult=DialogResult.OK; buttonCancel.DialogResult=DialogResult.Cancel;
        buttonOK.Text=strbutton; buttonCancel.Text="Cancel";   
        texthere.Text=strz; 
        formhere.Activated+=(o, e) => { 
            if (xf) {formhere.Location=new Point(xtoglobal(pxs[nfix]), ytoglobal(pys[0])); 
            } else {formhere.Location=new Point(xtoglobal(pxs[0]), ytoglobal(pys[nfix])); } 
        }; 
        DialogResult dr=formhere.ShowDialog(); 
        if (dr==DialogResult.OK) {
            strz=texthere.Text;
            if (xf) {xtitles[nfix]=strz; 
            } else {ytitles[nfix]=strz; } 
            recalcu(); } 
    } // ======================================================= 
    bool checkxy(int x, int y) { 
        if (terms[x,y].strincidents != "") {return true; } 
        if (terms[x,y].files.Count!=0) {return true; }
        return false; 
    } // ======================================================= 
    void remove (bool xf, int nfix) {
        if (xf) { 
            for (int y=0; y<ysz; y++) { 
                if (checkxy(nfix,y)) {MessageBox.Show(xtitles[nfix]+", "+ytitles[y]+" is not empty !"); 
                    return; } } 
            Term[,] tmnew=new Term[xsz-1, ysz]; 
            List<int> pxsnew=new List<int>(); 
            for (int x=0; x<=nfix; x++) {  
                pxsnew.Add(pxs[x]); }  
            for (int x=nfix+1; x<xsz; x++) {  
                pxsnew.Add(pxsnew[x-1]+pxs[x+1]-pxs[x]); } 
            for (int x=0; x<nfix; x++) {  
                for (int y=0; y<ysz; y++) {
                    tmnew[x, y]=terms[x, y]; } } 
            for (int x=nfix+1; x<xsz; x++) {   
                for (int y=0; y<ysz; y++) {
                    tmnew[x-1, y]=terms[x, y]; } } 
            xtitles.RemoveAt(nfix);  
            xopen.RemoveAt(nfix); 
            multiplierx.RemoveAt(nfix);
            accumx.RemoveAt(nfix);  
            pxs=pxsnew;
            terms=tmnew;
            xsz--; 
        } else {
            for (int x=0; x<xsz; x++) {
                if (checkxy(x,nfix)) {MessageBox.Show(xtitles[x]+", "+ytitles[nfix]+" is not empty !"); 
                    return; } }  
            Term[,] tmnew=new Term[xsz, ysz-1];
            List<int> psnew=new List<int>();  
            for (int y=0; y<=nfix; y++) { 
                psnew.Add(pys[y]); }  
            for (int y=nfix+1; y<ysz; y++) { 
                psnew.Add(psnew[y-1]+pys[y+1]-pys[y]); } 
            for (int y=0; y<nfix; y++) {  
                for (int x=0; x<xsz; x++) {
                    tmnew[x, y]=terms[x, y]; } } 
            for (int y=nfix+1; y<ysz; y++) {  
                for (int x=0; x<xsz; x++) {
                    tmnew[x, y-1]=terms[x, y]; } } 
            ytitles.RemoveAt(nfix); 
            yopen.RemoveAt(nfix); 
            multipliery.RemoveAt(nfix);
            accumy.RemoveAt(nfix); 
            pys=psnew;
            terms=tmnew;
            ysz--; } 
    } // =======================================================  
    void insert(bool xf, int nfix) {  
        if (xf) {  
            Term[,] tmnew=new Term[xsz+1, ysz]; 
            List<int> psnew=new List<int>();  
            for (int x=0; x<nfix; x++) {  
                psnew.Add(pxs[x]); 
                for (int y=0; y<ysz; y++) { 
                    tmnew[x, y]=terms[x, y]; } } 
            psnew.Add(pxs[nfix]); 
            xopen.Insert(nfix, false);  
            for (int y=0; y<ysz; y++) {
                tmnew[nfix, y]=new Term(); } 
            for (int x=nfix; x<=xsz; x++) {  
                psnew.Add(bandD+pxs[x]); }
            for (int x=nfix; x<xsz; x++) {  
                for (int y=0; y<ysz; y++) {
                    tmnew[x+1, y]=terms[x, y]; } } 
            xtitles.Insert(nfix,"");   
            multiplierx.Insert(nfix,1);
            accumx.Insert(nfix,0);  
            pxs=psnew;
            terms=tmnew;
            xsz++; 
        } else { 
            Term[,] tmnew=new Term[xsz, ysz+1];
            List<int> psnew = new List<int>();  
            for (int y=0; y<nfix; y++) { 
                psnew.Add(pys[y]); 
                for (int x=0; x<xsz; x++) {
                    tmnew[x, y]=terms[x, y]; } } 
            psnew.Add(pys[nfix]); 
            yopen.Insert(nfix, false);  
            for (int x=0; x<xsz; x++) {
                tmnew[x, nfix]=new Term(); }
            for (int y=nfix; y<=ysz; y++) { 
                psnew.Add(bandD+psnew[y]); } 
            for (int y=nfix; y<ysz; y++) {  
                for (int x=0; x<xsz; x++) {
                    tmnew[x, y+1]=terms[x, y]; } }  
            ytitles.Insert(nfix,""); 
            multipliery.Insert(nfix,1); 
            accumy.Insert(nfix,0); 
            pys=psnew;
            terms=tmnew;
            ysz++; } 
    } // =======================================================  
    public int xtoglobal(int xloc) {return xloc+8+(par.Location.X+this.Location.X); } 
    public int ytoglobal(int yloc) {return yloc+56+(par.Location.Y+this.Location.Y); } 
    public string getcontent() {
        string str= ""; 
        str += ysz.ToString()+"\r\n"; 
        for (int y=0; y<ysz; y++) { 
            str += ytitles[y]+"\r\n"; } 
        str += xsz.ToString()+"\r\n"; 
        for (int x=0; x<xsz; x++) {
            str += xtitles[x]+"\r\n"; } 
        for (int y=0; y<ysz; y++) { 
            for (int x=0; x<xsz; x++) {
                { 
                    string strhere=""; 
                    foreach (string stra in terms[x,y].files) { 
                        strhere += stra+"\r\n"; 
                    }
                    string strlen=strhere.Length.ToString() + "\r\n";
                    str += strlen + strhere;  
                } 
                {  
                    string strhere=terms[x, y].strincidents; 
                    if (strhere.Length == 1 || strhere.Length >=2 && strhere.Substring(strhere.Length-2,2) != "\r\n") {
                        strhere += "\r\n"; } 
                    int slen=strhere.Length;  
                    string strlen=slen.ToString()+"\r\n";
                    str += strlen + strhere; } } } 
        return str; 
    } // =========================================================== 
    Term[] lres=new Term[1000]; 
    public class FormSelection : Form { 
            // === a small Dialog to do "remove","insert","rename","nop" !!! 
        public string[] strs;
        public ListBox list; 
        public FormSelection(string[] strstf) {
            strs=strstf;
            list=new ListBox();
            this.FormBorderStyle=FormBorderStyle.None;
            list.Location=new Point(0, 0);
            Controls.Add(list); 
            this.Width=150;
            list.Width=this.Width; 
            foreach (string str in strstf) {
                list.Items.Add(str); } 
            list.Height=list.ItemHeight*list.Items.Count+2; 
            this.Height=list.Height;
            list.SelectedIndexChanged+=new EventHandler(list_SelectedIndexChanged);
        } // ====================================================================== 
        void list_SelectedIndexChanged (object sender, EventArgs e) { 
            Dispose();  
        } // ======================================================================  
    } // ########################################################################## 
} // ############################# MyTable.cs end ################################### 

