﻿// ############################### Term.cs ################################### 
using System.Collections.Generic; 
using System.Windows.Forms;  

public  class Term { 
    public long final; 
    public List<string> files; 
    public string strincidents="";  
    public Term() { 
        final=0; 
        files=new List<string>(); 
    } // ================================================== 
    public void setfiles(string stra) {
        int i=0;
        for ( ; i<stra.Length; ) { 
            int inex=stra.IndexOf("\r", i); 
            files.Add(stra.Substring(i, inex-i)); 
            i=inex+2; 
        } 
    } // ================================================== 
    public void recalcuterm() { 
        string stringa, stringb, stringc; 
        long laccum=todoexe(out stringa, out stringb, out stringc, strincidents); 
        final=laccum; 
    } // ================================================== 
    public static long todoexe(out string stringa, out string stringb, out string stringc, string textmultis) {
        stringa=""; stringb=""; stringc=""; 
        List<string> strings=tostrings(textmultis); 
        long[] llls=new long[strings.Count]; 
        int[] timess=new int[strings.Count]; 
        long laccum=0; 
        for (int i=0; i<strings.Count; i++) { 
            string strc=""; 
            int ib=0, ie=0, id=0, iinterval=1; 
            long lll=stranalysis(ref ib, ref ie, ref id, ref iinterval, ref strc, strings[i]); 
            int ic=ie+13-ib; if (ie >= ib) {ic-=12; }  // 0,1,2 
            ic = (ic / iinterval); 
            string strb=ib.ToString()+" "+ie.ToString()+" "+id.ToString()+" "+ic.ToString(); 
            laccum += ic*lll; 
            stringa += lll.ToString("n0")+"\r\n"; 
            stringb += strb+"\r\n"; 
            stringc += strc+"\r\n"; } 
        return laccum; 
    } // =================================================  
    public static List<string> tostrings(string textmultis) { 
        List<string> strings=new List<string>();
        string strline=""; 
        for (int i=0; i<textmultis.Length; i++) { 
            if (textmultis[i] == '\r') {
                strings.Add(strline);
                strline=""; 
                if (textmultis[i+1] == '\n') {i++; } 
                continue; 
            } else {
                strline += textmultis.Substring(i, 1); } } 
        if (strline != "") { 
            strings.Add(strline); }
        return strings; 
    } // =================================================== 
    static long stranalysis (ref int ib, ref int ie, ref int id, ref int iinterval, 
                    ref string strc, string str) {
        int i=0; toY(ref i, str);
        int i0=i; toN(ref i, str); 
        int i1=i; toY(ref i, str);
        int i2=i; toN(ref i, str); 
        int i3=i; toY(ref i, str);
        int i4=i;
        ib=0; ie=0; id=0; 
        bool pb=parseday(ref ib, ref ie, ref id, ref iinterval, str.Substring(i2,i3-i2)); 
        if (pb) {strc=str.Substring(i4); // === strc is comment !!! 
        } else {strc=str.Substring(i2); } 
        long lll=0; 
        try { 
            lll=long.Parse(str.Substring(i0,i1-i0)); 
        } catch { }
        return lll; 
    } // ================================================= 
    static void toY(ref int i, string str) { 
        for ( ; i<str.Length; i++) { 
            if (str[i] != ' ' && str[i] != '\t') {
                break; } } 
    } // ================================================= 
    static void toN(ref int i, string str) {
        for ( ; i<str.Length; i++) { 
            if (str[i] == ' ' || str[i] == '\t') {
                break; } }
    } // =================================================  
    public static bool parseday(ref int ib, ref int ie, ref int id, ref int iinterval, string str) { 
        int intt=str.IndexOf('/'), intm=str.IndexOf('-'); 
        if (intt < 0) {intt=str.Length; }  
        if (intm < 0) {intm=intt; }
        ib=0; 
        if (intm > 0) { 
            try { 
                ib=int.Parse(str.Substring(0, intm)); 
                if (ib < 0 || ib > 12) {
                    ib=0; 
                    return false; }
            } catch { 
                MessageBox.Show("Wrong character for number is used !!!"); 
                return false; 
            } 
        } else {
            return false; }  
        id=0;  
        if (intt+1 < str.Length) { 
            try {
                id=int.Parse(str.Substring(intt+1)); 
            } catch {
                return false; 
            } 
        }   
        try {  
            iinterval = 1;
            int intb = intm+1; 
            for ( ; intb < str.Length; intb++, iinterval++) {
                if (str[intb] != '-') { break; } 
            } 
            ie=int.Parse(str.Substring(intb, intt-intb)); 
        } catch {  
            ie=ib; 
        } 
        if (ie <= 0 || ie > 12) { 
            ib=0; ie=0; id=0; 
            return false;
        } 
        if (ib == 0) { ie=0; id=0; } 
        if (id < 0 || id > 31) {id=0; } 
        return true; 
    } // ================================================= 
} // ###################################### Term.cs end ######################################### 
