﻿// ######################################## TermForm.cs ##########################################
using System; 
using System.Windows.Forms; 
using System.Drawing; 
using System.Collections; 
public class TermForm : Form { 
    public Point location; 
    public Term term; 
    Button buttonOK, buttonCancel;
    Button buttonPicture;  
    public ListBox combo; 
    public TextBox textfinalz;   
    public TextBox textmulti, amountmulti, bmountmulti, cmountmulti; 
    Hashtable hash; 
    public string strbase; 
    public TermForm(Term termtf, string strbasetf, string titlex, string titley) { 
        strbase=strbasetf; 
        this.Size=new Size(810,504); 
        this.Text=titlex+" : "+titley; 
        term=termtf; 
        buttonOK=new Button(); buttonCancel=new Button(); 
        buttonOK.SetBounds(10, 10, 50, 20); 
        buttonCancel.SetBounds(70, 10, 50, 20); 
        Controls.Add(buttonOK); Controls.Add(buttonCancel); 
        buttonOK.Text="OK"; 
        buttonCancel.Text="Cancel"; 
        buttonOK.DialogResult=DialogResult.OK; 
        buttonCancel.DialogResult=DialogResult.Cancel; 
        combo=new ListBox(); // === to select receipts !!! 
        combo.SetBounds(130, 10, 650, 90); 
        Controls.Add(combo);
        combo.SelectedValueChanged+=(o, e) => {  
            if (combo.SelectedItem==null) {return; } 
            string str=combo.SelectedItem.ToString(); 
            string stradded=straddfname(strbase, str); 
            DialogResult dr=callfile(stradded, false); // === to select !!! 
            if (dr==DialogResult.Yes) {combo.Items.Remove(combo.SelectedItem); } }; 
        hash=new Hashtable(); 
        {
            Label label=new Label();
            label.SetBounds(10, 65, 30, 15);
            label.Text="total";
            Controls.Add(label); 
        } 
        textfinalz=new TextBox(); 
        textfinalz.SetBounds(10, 80, 110, 20); 
        textfinalz.TextAlign=HorizontalAlignment.Right;
        Controls.Add(textfinalz);
        textfinalz.Enabled=false;
        buttonPicture=new Button(); 
        buttonPicture.SetBounds(50, 40, 70, 20); 
        buttonPicture.Text="add image";
        buttonPicture.Click+=(o, e) => {  
            FileDialog fd=new OpenFileDialog(); 
            fd.FileName=strbase;  
            fd.Filter = "Img files(*.jpg,png,bmp,gif,pdf)" +
                "|*.jpg; *.jpeg; *.jpe; *.jfif; *.png; *.bmp; *.gif; *.pdf|All files (*.*)|*.*";  
            DialogResult dr=fd.ShowDialog(); 
            if (dr==DialogResult.OK) { 
                DialogResult dr2=callfile(fd.FileName, true); // === to add !!! 
                if (dr2 == DialogResult.OK) { 
                    string strdiffe=strsubfname(fd.FileName, strbase); 
                    combo.Items.Add(strdiffe); } } }; 
        Controls.Add(buttonPicture); 
        textfinalz.Text=term.final.ToString("n0");
        // 
        int yl=115;
        {
            Label label=new Label();
            label.SetBounds(10, yl, 70, 15);
            label.Text="amount"; 
            Controls.Add(label);
        } 
        {
            Label label=new Label();
            label.SetBounds(90, yl, 70, 15);
            label.Text="bg ed dy ct"; 
            Controls.Add(label);
        } 
        {
            Label label=new Label();
            label.SetBounds(170, yl, 105, 15);
            label.Text="head of comment"; 
            Controls.Add(label);
        } 
        {
            Label label=new Label(); 
            label.SetBounds(280, yl, 300, 15);
            label.Text="amount   month(-month)/day   comment";
            Controls.Add(label);
        } 
        // 
        int y=130; 
        amountmulti=new TextBox();
        amountmulti.SetBounds(10, y, 70, 330); 
        amountmulti.Multiline=true;
        amountmulti.TextAlign=HorizontalAlignment.Right;
        amountmulti.Enabled=false; 
        Controls.Add(amountmulti); 
        // 
        bmountmulti=new TextBox();
        bmountmulti.SetBounds(90, y, 70, 330); 
        bmountmulti.Multiline=true; 
        bmountmulti.Enabled=false; 
        Controls.Add(bmountmulti);
        // 
        cmountmulti=new TextBox(); 
        cmountmulti.SetBounds(170, y, 100, 330);
        cmountmulti.Multiline=true; 
        cmountmulti.Enabled=false;  
        Controls.Add(cmountmulti); 
        //
        textmulti=new TextBox();
        textmulti.SetBounds(280, y, 500, 330); 
        textmulti.AcceptsTab=true; 
        textmulti.Multiline=true;
        textmulti.TextChanged+=(o, e) => { 
            string stringa, stringb, stringc; 
            long laccum=Term.todoexe(out stringa, out stringb, out stringc, textmulti.Text);  
            amountmulti.Text=stringa;
            bmountmulti.Text=stringb;
            cmountmulti.Text=stringc;
            textfinalz.Text=laccum.ToString("n0");
            term.final=laccum; };
        Controls.Add(textmulti);  
    } // =================================================== 
    DialogResult callfile(string strName, bool activef) { 
        string fname=strName;
        string strpost = getPostfix(fname); 
        int w=170, h=0; 
        Form fm=new Form();
        fm.BackColor=Color.LightGray; 
        int wd=120, hd=100; 
        try{
            Bitmap obj = (Bitmap)Bitmap.FromFile(fname); 
            int wo=obj.Width, ho=obj.Height; 
            if (w<wo) {w=wo; } 
            if (h<ho) {h=ho; }
            if (w>h) { wd = 600; hd = 600 * h / w; 
            } else {
                hd = 600; wd = 600 * w / h; 
            } 
            fm.Size=new Size(wd+17, hd+60);
            fm.Paint+=(oo,ee) => {
                Graphics g=ee.Graphics; 
                g.DrawImage(obj, new Rectangle(0, 21, wd, hd)); }; 
        } catch { } 
        Button buttonCancelT=new Button();
        buttonCancelT.Text = "Cancel";
        buttonCancelT.DialogResult = DialogResult.Cancel; 
        buttonCancelT.SetBounds(wd/2-100, 0, 60, 20); 
        fm.Controls.Add(buttonCancelT);
        if (activef) {
            Button buttonOKT=new Button();
            buttonOKT.SetBounds(wd/2-30, 0, 60, 20);  
            buttonOKT.DialogResult=DialogResult.OK; 
            buttonOKT.Text="Add"; 
            fm.Controls.Add(buttonOKT); 
        } else {  
            Button buttonDelT=new Button();
            buttonDelT.SetBounds(wd/2-30, 0, 60, 20);  
            buttonDelT.DialogResult=DialogResult.Yes; 
            buttonDelT.Text="Remove"; 
            fm.Controls.Add(buttonDelT); } 
        if (strpost == "pdf") {
            Button buttonShowT= new Button();
            buttonShowT.Text = "Show"; 
            buttonShowT.SetBounds(wd/2+40, 0, 60, 20);
            fm.Controls.Add(buttonShowT); 
            buttonShowT.Click += (o, e) => {  
                System.Diagnostics.Process.Start("EXPLORER.EXE", 
                    strName);  
            }; 
        }  
        fm.Activated+=(o, e) => { fm.Location=new Point(this.Location.X+50, this.Location.Y); }; 
        DialogResult dr2=fm.ShowDialog();
        return dr2; 
    } // ================================================== 
    string strfl=""; 
    bool usedf=false; 
    protected override void OnActivated (EventArgs e) { 
        if (!usedf) { 
            Location=location;  
            usedf=true; } 
    } // ==================================================  
    Image image=null; 
    protected override void OnPaint (PaintEventArgs e) {
        Graphics g=e.Graphics; 
        if (strfl != "") {
            image=Image.FromFile(strfl);
            g.DrawImage(image,0,0); }  
    } // ==================================================  
    public static string straddfname(string strm, string stradder) {
        int ctm=0, i; 
        for ( ; ; ) {
            if (stradder.Substring(0,3) == "..\\") {
                stradder=stradder.Substring(3); 
                ctm++; 
            } else {break; } 
        } 
        for (i=strm.Length-1; i>=0; i--) { 
            if (strm[i] == '\\' || strm[i] == ':') {ctm--; } 
            if (ctm < 0) {break; } 
        }
        string stra=strm.Substring(0, i+1)+stradder;
        return stra; 
    } // =========================================================================== 
    public static string strsubfname(string strs, string strm) { 
        int lens=strs.Length, lenm=strm.Length, lenf=lens; if (lenf>lenm) {lenf=lenm; }  
        int lasti=0; 
        for (int i=0; i<lenf; i++) { 
            if (strs[i] != strm[i]) {break; } 
            if (strs[i] == '\\') {lasti=i; } } 
        int ctm=0;
        string stra=""; 
        for (int i=lasti+1; i<lenm; i++) {
            if (strm[i] == '\\') { ctm++; stra += "..\\"; } 
        }
        stra += strs.Substring(lasti+1);
        return stra; 
    } // =========================================================================== 
	public static string getPostfix(string filename) { 
		int ind=filename.IndexOf(".", 0); 
		for ( ; ; ) { 
			int indnw=filename.IndexOf(".", ind+1); 
			if (indnw < 0) {break; } 
			ind=indnw; } 
		return filename.Substring(ind+1);  
    } // ==========================================================================  
} // ################################## TermForm.cs end ###################################### 
