﻿// ###################################### MyForm.cs ########################################## 
using System.Windows.Forms;
using System;
using System.Collections.Generic; 

public class MyForm : Form { 
    [System.STAThread]
    static void Main() {
        Application.Run(new MyForm());
    } // ==================================================================== 
    public Panel basepanel; 
    public string strbase = Environment.CurrentDirectory;
    ToolStripMenuItem menu_File; 
    public MyTable myTable; 
    string strdir; 
    public string strpivot;  
    public MyForm() {
        this.Controls.Add(MainMenuStrip = new MenuStrip());
        MainMenuStrip.Location = new System.Drawing.Point(0, 0);
        MainMenuStrip.Size = new System.Drawing.Size(800, 24);
        MainMenuStrip.TabIndex = 0; 
        menu_File=MainMenuStrip.addItem("ファイル(&F)"); 
        menu_File.addItem("開く").Click+=(o, e) => {
            
            FileDialog fd=new OpenFileDialog();
            fd.Filter="yer files (*.yer)|*.yer|All files (*.*)|*.*"; 
            string strinit=Environment.CurrentDirectory; ; //  getinitialdir(); 

            fd.InitialDirectory = strinit; 
            DialogResult dr = fd.ShowDialog(); 
            if (dr == DialogResult.OK) { 
                strpivot=fd.FileName; 
                int idir=strpivot.Length-1; 
                for ( ; idir>0; idir--) { 
                    if (strpivot.Substring(idir, 1) == "\\") { 
                        break; } } 
                strbase=strpivot.Substring(0, idir+1); 
                this.Text=strpivot; }
            if (strpivot == null) { return; }  
            fileread();   
            Refresh(); }; 

         
        menu_File.DropDownItems.Add(new ToolStripSeparator()); 
        menu_File.addItem("名前を付けて保存").Click+=(o, e) => { 
            FileDialog fd=new SaveFileDialog(); 
            fd.Filter="yer files (*.yer)|*.yer|All files (*.*)|*.*";  
            fd.InitialDirectory = getinitialdir();  
            DialogResult dr = fd.ShowDialog(); 
            if (dr == DialogResult.OK) { 
                strpivot=fd.FileName; 
                string strsubt=strsubfname(strpivot, strbase); 
                this.Text=strsubt+" --- "; }
            string nm = fd.FileName;
            strpivot = nm; 
            filewrite(nm); }; 
        menu_File.addItem("上書き保存").Click+=(o, e) => { 
            filewrite(strpivot); };  
        // 
        basepanel = new Panel(); 
        basepanel.AutoScroll = true;
        basepanel.Dock = DockStyle.Fill; // located at (0,0) 
        Controls.Add(basepanel);
        //   
        basepanel.Controls.Add(myTable = new MyTable(this)); 
        myTable.Location = new System.Drawing.Point(0, 24); 
        myTable.getpxs();   
        myTable.getpys();   
        // 
        this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
        this.ClientSize = new System.Drawing.Size(500, 500);
        this.Text = "MyForm";
        //
        FileDialog fda=new OpenFileDialog();
        fda.Filter="yer files (*.yer)|*.yer|All files (*.*)|*.*"; 
        string strinita=Environment.CurrentDirectory; ; //  getinitialdir(); 
        string strpivotmarea = strinita + "\\index.yer"; 
        if (System.IO.File.Exists(strpivotmarea)) {
            this.Text = strpivot= strpivotmarea; 
            fileread();   
            Refresh(); }; 

    } // ======================================================================= 
    string getstr(ref int c, string str) { 
        int ir=str.IndexOf("\r", c); 
        string stri=str.Substring(c, ir-c); 
        int il=int.Parse(stri);
        c=ir+2; 
        string stra=str.Substring(c, il);
        c += il; 
        return stra; 
    } // ======================================================= 
    List<string> getstrs(ref int c, string str) {
        int ir=str.IndexOf("\r", c);
        int il=int.Parse(str.Substring(c, ir-c)); 
        c=ir+2; 
        List<string> titles=new List<string>(); 
        for (int j=0; j<il; j++) {
            int c1=str.IndexOf("\r", c);
            titles.Add(str.Substring(c, c1-c)); 
            c=c1+2; }
        return titles; 
    } // ======================================================= 
    string getinitialdir() {
        strdir = Environment.CurrentDirectory; 
        int ii=strdir.Length-1, ct=0; 
        for( ; ii>=0; ii--) {
            if (strdir.Substring(ii,1)=="\\") {ct++; } 
            if (ct==3) {break; } } 
        string toret=strdir.Substring(0,ii);
        return toret; 
    } // ======================================================= 
    void fileread() { 
        /* 
        FileDialog fd=new OpenFileDialog();
        fd.Filter="yer files (*.yer)|*.yer|All files (*.*)|*.*"; 
        fd.InitialDirectory = getinitialdir(); //         strdir.Substring(0,ii); 
        DialogResult dr = fd.ShowDialog(); 
        if (dr == DialogResult.OK) { 
            strpivot=fd.FileName; 
            int idir=strpivot.Length-1; 
            for ( ; idir>0; idir--) { 
                if (strpivot.Substring(idir, 1) == "\\") { 
                    break; } } 
            strbase=strpivot.Substring(0, idir+1); 
            {   string strsubt=strsubfname(strpivot, strbase); 
                this.Text=strsubt+" --- "; } } 
        if (strpivot == null) { return; } */ 
        System.IO.FileStream fst = new System.IO.FileStream( 
				strpivot, System.IO.FileMode.Open, 
				System.IO.FileAccess.Read, System.IO.FileShare.None); 
		int filelen=(int)fst.Length; 
		byte[] bytes=new byte[filelen]; 
		for (int i=0; i<filelen; i++) { 
			bytes[i]=(byte)fst.ReadByte(); }  
		fst.Close();   
        string str=System.Text.Encoding.Default.GetString(bytes);
        List<string> strs=new List<string>(); 
        int c=0;
        List<string> titlesy=getstrs(ref c, str), titlesx=getstrs(ref c, str);
        myTable.settitles(titlesx, titlesy); 
        int ysz=titlesy.Count, xsz=titlesx.Count; 
        for (int y=0; y<ysz; y++) { 
            for (int x=0; x<xsz; x++) {
                string stra=getstr(ref c, str); 
                string strb=getstr(ref c, str);
                myTable.setcontent(x, y, stra, strb);
                myTable.terms[x, y].recalcuterm(); } }
        myTable.recalcu(); 
        myTable.getpxs();
        myTable.getpys(); 
    } // ======================================================== 
    void filewrite (string nm) {
        string str =myTable.getcontent(); 
        strpivot=nm; 
        int idir=strpivot.Length-1; 
        for ( ; idir>0; idir--) { 
            if (strpivot.Substring(idir, 1) == "\\") { 
                break; } } 
        strbase=strpivot.Substring(0, idir+1); 
        {   string strsubt=strsubfname(strpivot, strbase); 
            this.Text=strsubt+" --- "; }  
        System.IO.StreamWriter sw = new System.IO.StreamWriter(strpivot,false, System.Text.Encoding.Default);
        sw.Write(str);
        sw.Flush();
        sw.Close(); 
    } // ======================================================= 
    protected override void OnActivated(EventArgs e) {
        myTable.Refresh(); 
    } // ======================================================================= 
    protected override void Dispose(bool disposing) { 
        base.Dispose(disposing);
    } // =======================================================================  
	public static string getPostfix(string filename) { 
		int ind=filename.IndexOf(".", 0); 
		for ( ; ; ) { 
			int indnw=filename.IndexOf(".", ind+1); 
			if (indnw < 0) {break; } 
			ind=indnw; } 
		return filename.Substring(ind+1);  
    } // ==========================================================================  
    public static string strsubfname(string strs, string strm) { 
        int lens=strs.Length, lenm=strm.Length, lenf=lens; if (lenf>lenm) {lenf=lenm; }  
        int lasti=0; 
        for (int i=0; i<lenf; i++) { 
            if (strs[i] != strm[i]) {break; } 
            if (strs[i] == '\\') {lasti=i; } } 
        int ctm=0;
        string stra=""; 
        for (int i=lasti+1; i<lenm; i++) {
            if (strm[i] == '\\') { ctm++; stra += "..\\"; } 
        }
        stra += strs.Substring(lasti+1);
        return stra; 
    } // =========================================================================== 
} // ################################## MyForm.cs end #########################################